import static java.lang.System.out;

import java.util.Date;

public class PrintfDemo
{
 public static void main( String[] args )
 { 
  int i = 123;

  out.printf( "|%d|   |%d|%n" ,     i, -i );   // |123|   |-123|
  out.printf( "|%5d| |%5d|%n" ,     i, -i );   // |  123| | -123|
  out.printf( "|%-5d| |%-5d|%n" ,   i, -i );   // |123  | |-123 |
  out.printf( "|%+-5d| |%+-5d|%n" , i, -i );   // |+123 | |-123 |
  out.printf( "|%05d| |%05d|%n%n",  i, -i );   // |00123| |-0123|

  out.printf( "|%X| |%x|%n", 0xabc, 0xabc );   // |ABC| |abc|
  out.printf( "|%08x| |%#x|%n%n", 0xabc, 0xabc ); // |00000abc| |0xabc|

  double d = 12345.678;

  out.printf( "|%f| |%f|%n" ,         d, -d ); // |12345,678000| |-12345,678000|
  out.printf( "|%.2f| |%.2f|%n" ,     d, -d ); // |12345,68| |-12345,68|
  out.printf( "|%,10f| |%,10f|%n" ,   d, -d ); // |1234,567800| |-1234,567800|
  out.printf( "|%10.2f| |%10.2f|%n" , d, -d ); // |  12345,68| | -12345,68|
  out.printf( "|%010.2f| |%010.2f|%n",d, -d ); // |0012345,68| |-012345,68|

  String s = "Monsterbacke";

  out.printf( "%n|%s|%n", s );                 // |Monsterbacke|
  out.printf( "|%20s|%n", s );                 // |        Monsterbacke|
  out.printf( "|%-20s|%n", s );                // |Monsterbacke        |
  out.printf( "|%7s|%n", s );                  // |Monsterbacke| 
  out.printf( "|%.7s|%n", s );                 // |Monster|
  out.printf( "|%20.7s|%n", s );               // |             Monster|
    
  Date t = new Date();
  out.printf( "%tT%n", t );                    // 11:01:39
  out.printf( "%tD%n", t );                    // 05/23/06
  out.printf( "%1$te. %1$tb%n", t );           // 23. Mai
 }
}
